// Copyright 2015 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

assertEquals(1, v8ToPrimitive(1));
assertEquals(1, v8ToPrimitive_Number(1));

assertEquals(.5, v8ToPrimitive(.5));
assertEquals(.5, v8ToPrimitive_Number(.5));

assertEquals(null, v8ToPrimitive(null));
assertEquals(null, v8ToPrimitive_Number(null));

assertEquals(true, v8ToPrimitive(true));
assertEquals(true, v8ToPrimitive_Number(true));

assertEquals(false, v8ToPrimitive(false));
assertEquals(false, v8ToPrimitive_Number(false));

assertEquals(undefined, v8ToPrimitive(undefined));
assertEquals(undefined, v8ToPrimitive_Number(undefined));

assertEquals("random text", v8ToPrimitive("random text"));
assertEquals("random text", v8ToPrimitive_Number("random text"));

assertEquals(Symbol.toPrimitive, v8ToPrimitive(Symbol.toPrimitive));
assertEquals(Symbol.toPrimitive, v8ToPrimitive_Number(Symbol.toPrimitive));

var a = { toString: function() { return "xyz" }};
assertEquals("xyz", v8ToPrimitive(a));
assertEquals("xyz", v8ToPrimitive_Number(a));

var b = { valueOf: function() { return 42 }};
assertEquals(42, v8ToPrimitive(b));
assertEquals(42, v8ToPrimitive_Number(b));

var c = {
  toString: function() { return "x"},
  valueOf: function() { return 123 }
};
assertEquals(123, v8ToPrimitive(c));
assertEquals(123, v8ToPrimitive_Number(c));

var d = {
  [Symbol.toPrimitive]: function(hint) { return hint }
};
assertEquals("default", v8ToPrimitive(d));
assertEquals("number", v8ToPrimitive_Number(d));

var e = new Date(0);
assertEquals(e.toString(), v8ToPrimitive(e));
assertEquals(0, v8ToPrimitive_Number(e));
